%ifndef __AF_MATH__
%define __AF_MATH__


;
;     Fosforova matematicka ASM knihovna
;
;     (c) by Aaka Fosfor, 2007
;     jabber: fosfor@jabber.cz
;     icq: 96560956
;     email: fosfor.software@seznam.cz
;
;     posledni uprava: 26.3.2007
;


; ----------------------------------------------------------------------
;           obsah knihovny
; ----------------------------------------------------------------------

; (eax podil, edx zbytek) deleni32 (eax delenec, ebx delitel)
;	vydeli dve 32-bit cisla, vysledek i zbytek je take 32-bit


; ----------------------------------------------------------------------
;           vlastni funkce
; ----------------------------------------------------------------------


; deleni32
; vydeli dve 32-bit cisla, vysledek i zbytek je take 32-bit
; vstup:  eax - delenec, ebx - delitel
; vystup: eax - podil, edx - zbytek
deleni32:
	push cx

	xor edx, edx

	mov cx, 33
deleni32_cyklus:
	cmp edx, ebx
	jl deleni32_dalsi
	sub edx, ebx
deleni32_dalsi:
	rcl eax, 1
	rcl edx, 1
	loop deleni32_cyklus

	shr edx, 1
	not eax

	pop cx
	ret

%endif ;__AF_MATH__